#define DOWH_C TRUE
/* ========================================================================
 * Name - dowh.c
 *
 * Description - 
 *
 * $Id: dowh.c,v 1.2 1992/09/15 22:36:54 penneyj Exp $
 *
 * $Log: dowh.c,v $
 * Revision 1.2  1992/09/15  22:36:54  penneyj
 * misc facelift, preparing for distribution on alt.sources
 *
 * Revision 1.1  1992/09/15  22:18:47  penneyj
 * Initial revision
 *
 *========================================================================
 */

#include "general.h"
#include "config.h"

#include "list.h"
#include "main.h"
#include "match.h"
#include "utils.h"

#include "dowh.h" /* this file's interface */
     
     
/*
 *  The matching testing of whatis and apropos
 */
#if defined(FLG_PROTOTYPE)
void domatching(const char *nameinfile, FILE *outfile)
#else
void domatching(nameinfile, outfile)
const char *nameinfile;
FILE *outfile;
#endif
{
  FILE * infile;
  ListType item;
  char *key;
  char buffer[BUFFERSIZE];
  matchfunctype *match;

  if (whattodo == INVOKED_APROPOS)
    match = amatch;
  else
    match = wmatch;
  infile = fopen(nameinfile, "r");
  if (infile == NULL)
    return;
  if (debug_f)
    warning("Searching %s", nameinfile);
  if ((*keywords)->next == NULL) {
    int  keylen;

    key = (*keywords)->key;
    keylen = strlen(key);
    if (whattodo == INVOKED_APROPOS) {
      /*
       *  At this point, there is some very rotten code.
       *  Beware!
       */
#define MAXCHAR 256
      char *buf, *where, *theEnd;
      long size;		    
      char jmptbl[MAXCHAR];
      int i, hopp;

      for (i = 0; i < MAXCHAR; i++)
	jmptbl[i] = keylen;
      for(i = 0; i < keylen; i++)
	 jmptbl[key[i]] = keylen - i - 1;
      fseek(infile, 0 , 2);
      size = ftell(infile);
      buf = MyMalloc(size + keylen + 16);
      rewind(infile);
      *buf = '\0';
      fread(buf+1, size, 1, infile);
      where = buf + keylen;
      if (buf[size+1] == '\0')
	strcpy(buf+size+2,key);
      else {
	printf("Fatal error!\n");
	die(INTERNERROR);
	}

again:
      hopp=1;
      while (hopp != 0) {
	hopp = jmptbl[*where];
	where += hopp ;
	}
		
      if (where >= buf+size)
	return;
      where -= keylen;
      where++;
		
      if (strncmp(where,key,keylen) == 0) {
	/* fprintf(stdout,"Found!\n"); */
	while ((*where != '\n') && (*where != '\0'))
	  where-- ;
	where++ ;
	theEnd = strchr(where,'\n');
	if (theEnd == NULL) {
	  theEnd = strchr(where,'\0');
	  if (theEnd == NULL) {
	    fprintf(stderr, "Nonterminated string - this can't happen!\n");
	    die(INTERNERROR);
	    }
	  }
	*theEnd = '\0';
	fprintf(outfile,"%s\n",where);
	where = theEnd + 1;
	}
      else {
#if 0
	/* where[keylen]=0; printf("at: %s\n",where); */
#endif
	where += keylen+1;
	}
      goto again;
      /*
       *  End of rotten-as-slime code.
       */
      }
    else {
      while (fgets(buffer, BUFFERSIZE, infile) != NULL)
        if ((*match)(buffer, key, keylen))
	  fprintf(outfile, "%s", buffer);
      }
    }
  else {
    while (fgets(buffer, BUFFERSIZE, infile) != NULL)
      LIST_DO (keywords) {
	key = (*item)->key;
	if ((*match)(buffer, key, strlen(key)))
	  fprintf(outfile, "%s", buffer);
	}
     }
  fclose(infile);
}



/*
 *  This function does apropos and whatis. 
 */
#if defined(FLG_PROTOTYPE)
void dowhatis(void)
#else
void dowhatis() 
#endif
{
  ListType item;
  const char *this;
  char buffer[BUFFERSIZE];
  FILE * outfile;
  long foundflag;

  this = tmpfilename();
  outfile = fopen(this, "w");
  if (outfile == NULL) {
    warning("Couldn't open %s", this);
    perror(this);
    die(FILERROR);
    }
  ADDTOLIST(showfiles, this);

#if defined(DEFAULTWHATIS)
  domatching(DEFAULTWHATIS, outfile);
#endif /* DEFAULTWHATIS */

  LIST_DO (searchtrees) {
    this = (**item).key;
    sprintf(buffer, "%s%s", this, "/whatis");
    domatching(buffer, outfile);
    }

  fflush(outfile);
  foundflag = ftell(outfile);
  fclose(outfile);
  if (!foundflag) {
    fprintf(stderr, "Nothing appropriate\n");
    cleanup();
    /* This isn't the way to do this, maybe. */
    die(NOSUCHTHING);
    }
}
